<template>
  <AppModal
    name-modal="modal-auth"
    :width-modal="520"
    :visible="visible"
    :gray-header="true"
    @before-close="beforeClose"
    @before-open="beforeOpen"
    init-class="modalAuthorization">
    <template #header>
      <div class="selectableHeading">
        <div
          @click="switchTab('auth')"
          :class="{'-active': isTabAuth}"
          class="selectableHeading-item">Вход</div>
        <div
          @click="switchTab('register'); $ym('modal_authorization_registration_open')"
          :class="{'-active': isTabRegister}"
          class="selectableHeading-item">Регистрация</div>
      </div>
    </template>
    <div
      slot="body"
      class="authorization">


      <!-- TODO: разбить формы на компоненты -->

      <!-- Форма авторизации -->
      <div
        v-show="isTabAuth"
        class="authorization-form">
        <div class="form">
          <div class="form-item _top-padding">
            <AppInputComposite
              v-model="formAuth.username"
              type="text"
              name="username">
              <template #label>Ваш E-mail</template>
            </AppInputComposite>
          </div>

          <div
            class="form-item _no-padding">
            <AppInputComposite
              v-model="formAuth.password"
              type="password"
              name="password">
              <template #label>Пароль</template>
            </AppInputComposite>
            <!--     Нужен ли нам такой функционал  -->
            <!--              <i-->
            <!--                class="link advanced icon eye"-->
            <!--                v-password-control="'password'"/>-->
          </div>

          <div class="form-item _column _flex-end _no-padding">
            <!--     Есть ли у нас данный функционал?     -->
            <!--       <AppCheckbox>
                        <template #label>Запомнить пароль?</template>
                      </AppCheckbox>-->
            <AppButton
              :classes="['buttonAsLink', 'link', '_transparent']"
              @click.native="resetPassword(); $ym('modal_authorization_forgot_password_open')">
              <span
                slot="button-item"
                class="button-item">
                Забыли пароль?
              </span>
            </AppButton>
          </div>

          <div
            class="form-item _column"
            v-if="error">
            <div
              class="input-message-error"
              v-html="error"/>
          </div>

          <div class="form-item">
            <AppButton
              :disabled="isSubmitAuthDisabled"
              @click.native="submitFormAuth();$ga('Shag1','Click46');$ym('modal_authorization_button_enter')">
              <span
                slot="button-item"
                class="button-item">
                Войти
              </span>
            </AppButton>
          </div>


        </div>
      </div>
      <!-- Нет такого функционала -->
      <!--
      <div class="authorization-scl">
        <div class="authorization-scl-title">
          Вход через социальные сети
        </div>
        <ul class="authorization-scl-list">
          <li class="authorization-scl-item">
            <a href="#">
              <img
                svg-inline
                src="~/assets/svg/redesign/auth-social-google.svg">
            </a>
          </li>
          <li class="authorization-scl-item">
            <a href="#">
              <img
                svg-inline
                src="~/assets/svg/redesign/auth-social-vk.svg">
            </a>
          </li>
          <li class="authorization-scl-item">
            <a href="#">
              <img
                svg-inline
                src="~/assets/svg/redesign/auth-social-fb.svg">
            </a>
          </li>
        </ul>
      </div>
      -->

      <!--Форма регистрации -->
      <div
        v-show="isTabRegister"
        class="authorization-form">
        <div class="form">

          <div class="form-item">
            <AppCheckbox v-model="formRegister.isOrganization">
              <template #label>
                Я регистрируюсь как компания
              </template>
            </AppCheckbox>
          </div>

          <div class="form-item">
            <!--
            <div
              :class="{'-invalid': validation.hasError('formRegister.username')}"
              class="input inputComposite">
              <input
                class="input-field"
                type="text"
                name="username"
                v-model="formRegister.username">
              <span class="inputComposite-label">Ваш E-mail</span>
            </div>
            -->
            <AppInputComposite
              v-model="formRegister.username"
              type="text"
              name="username"
              :class="{ '-invalid': validation.hasError('formRegister.username') }">
              <template #label>Ваш E-mail</template>
            </AppInputComposite>
            <div
              v-if="validation.hasError('formRegister.username')"
              class="input-message-error _left">
              {{ validation.firstError('formRegister.username') }}
            </div>
          </div>

          <div class="form-item">
            <AppInputComposite
              v-model="formRegister.password"
              type="password"
              name="password"
              :class="{ '-invalid': validation.hasError('formRegister.password') }">
              <template #label>Пароль</template>
            </AppInputComposite>
            <div
              v-if="validation.hasError('formRegister.password')"
              class="input-message-error _left">
              {{ validation.firstError('formRegister.password') }}
            </div>
          </div>

          <div class="form-item">
            <AppCheckbox
              v-model="formRegister.isReadedRules"
              class="_label-small">
              <template #label>
                Принимаю
                <flink
                  href="/about-us/regulations"
                  target="_blank"
                  class="link">условия работы сайта</flink> и даю согласие <br> на
                <flink
                  href="/about-us/agreement"
                  target="_blank"
                  class="link">обработку персональных данных</flink>.
              </template>
            </AppCheckbox>
          </div>

          <div
            class="form-item _column"
            v-if="error">
            <div
              class="input-message-error"
              v-html="error"/>
          </div>

          <div class="form-item">
            <AppButton
              :disabled="isSubmitRegisterDisabled || !isPassedFormRegister"
              @click.native="submitFormRegister();$ga('Shag2','Click47');$ym('modal_authorization_button_register');">
              <span
                slot="button-item"
                class="button-item">
                Зарегистрироваться
              </span>
            </AppButton>
          </div>

        </div>
      </div>
    </div>

  </AppModal>
</template>

<script>
import SimpleVueValidation from 'simple-vue-validator';

import Modals from '~/assets/js/mixins/redesign/modals';
import Validator from '~/assets/js/validator';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
    minLength: 'Слишком короткий пароль.',
  },
});

export default {
  name: 'AppModalAuthorization',
  components: {
    AppModal,
    AppButton,
    AppCheckbox,
    AppInputComposite,
  },
  mixins: [Modals],
  data() {
    return {
      activeTab: 'auth',
      formAuth: {
        username: '',
        password: '',
      },
      formRegister: {
        username: '',
        password: '',
        isOrganization: false,
        isReadedRules: false,
      },
    };
  },
  computed: {
    isSubmitAuthDisabled() {
      return !Validator.notBlank(this.formAuth.username)
          || !Validator.notBlank(this.formAuth.password);
    },
    isSubmitRegisterDisabled() {
      return !this.formRegister.isReadedRules
          || !Validator.notBlank(this.formRegister.username)
          || !Validator.notBlank(this.formRegister.password);
    },
    isTabAuth() {
      return this.activeTab === 'auth';
    },
    isTabRegister() {
      return this.activeTab === 'register';
    },
    isPassedFormRegister() {
      return this.validation.isPassed('formRegister.username')
          && this.validation.isPassed('formRegister.password');
    },
  },
  validators: {
    'formRegister.username'(value) {
      return SimpleVueValidator.value(value).required().email();
    },
    'formRegister.password'(value) {
      return SimpleVueValidator.value(value).required().minLength(6);
    },
    'formRegister.isReadedRules'(value) {
      return this.validation.isTouched('formRegister.isReadedRules')
          && SimpleVueValidator.value(value).match(true);
    },
  },
  watch: {
    activeTab() {
      this.$emit('clear-error');
    },
  },
  methods: {
    submitFormAuth() {
      this.$emit('login', {
        username: this.formAuth.username,
        password: this.formAuth.password,
      });
    },
    submitFormRegister() {
      if (this.isPassedFormRegister) {
        this.$emit('createUser', {
          username: this.formRegister.username,
          password: this.formRegister.password,
          isOrganization: this.formRegister.isOrganization,
        });
      }
    },
    resetForms() {
      this.formAuth = {
        username: '',
        password: '',
      };

      this.formRegister = {
        username: '',
        password: '',
        isOrganization: false,
        isReadedRules: false,
      };
    },
    resetPassword() {
      this.$emit('reset-password');
    },
    switchTab(tabName) {
      if (this.activeTab !== tabName) {
        this.activeTab = tabName;
      }
    },
    beforeOpen() {
      this.switchTab('auth');
      this.resetForms();
      this.validation.reset();
      this.$emit('before-open');
    },
    beforeClose() {
      this.$emit('before-close');
      if (this.isTabAuth) {
        this.$ym('modal_authorization_auth_closed');
      }
      if (this.isTabRegister) {
        this.$ym('modal_authorization_reg_closed');
      }
    },
  },
};
</script>

<style lang="postcss">
  .modalAuthorization {
    .selectableHeading {
      display: flex;
      flex-direction: row;
      justify-content: space-around;
      align-items: center;
      min-width: 20rem;
      max-width: 21.25rem;
      height: 100%;
      margin: 0 auto -1px;
      padding: 0 1.25rem;
      text-align: center;

      &-item {
        position: relative;
        display: flex;
        align-items: center;
        justify-content: center;
        height: 100%;
        min-height: 3rem;
        padding: 0 0.625rem;
        font-family: var(--font-heading);
        font-size: 1.125rem;
        font-weight: var(--font-weight-medium);
        color: var(--color-main-lightest) !important;
        cursor: pointer;
        transition: all .3s var(--transition-easeOutQuad);
        user-select: none;

        &:after {
          content: "";
          position: absolute;
          width: 100%;
          opacity: 0;
          height: 0.125rem;
          background-color: var(--header-nav-active-border);
          bottom: 0;
          left: 0;
          transition: all .3s var(--transition-easeOutQuad);
        }

        &.-active {
          color: var(--color-main) !important;

          &:after {
            opacity: 1;
          }
        }
      }
    }

    .input-message-error {
      display: block;
      text-align: center;

      &._left {
        text-align: left;
      }
    }

    .authorization {
      &-form {
        display: flex;
        padding: 1rem 0 2rem;

        .form {
          display: flex;
          flex-direction: column;
          margin: 0 auto;
          height: 20rem;
          width: 100%;
          max-width: 21.25rem;

          &-item {
            font-size: 0.75rem;
            padding-bottom: 1.25rem;

            &._top-padding {
              padding-top: 2.5625rem;
            }

            &._no-padding {
              padding: 0;
            }

            &:last-child {
              margin-top: auto;
            }

            &._column {
              flex-direction: column;
            }

            &._flex-start {
              display: flex;
              justify-content: flex-start;
              align-items: flex-start;
            }

            &._flex-end {
              display: flex;
              justify-content: flex-end;
              align-items: flex-end;
            }

            .inputCheck-label {
              font-size: 0.875rem;
              color: var(--color-main);
            }

            & .inputCheck._label-small {
              & .inputCheck-label {
                font-size: 0.75rem;
              }
            }

            .inputComposite {
              width: 100%;
            }

            .buttonAsLink {
              display: inline-flex;
              padding: 0.5rem;
              height: auto;

              width: auto;
              margin-bottom: 1rem;
            }

            .link {
              white-space: nowrap;
            }
          }
        }
      }

      &-scl {
        display: block;
        padding: 0.5rem 0 2rem;
        text-align: center;

        &-title {
          display: block;
          padding-bottom: 1rem;
          font-size: 0.875rem;
        }

        &-list {
          display: flex;
          justify-content: center;
          align-items: center;
          margin: 0;
          padding: 0;
          list-style: none;
        }

        &-item + &-item {
          margin-left: 1rem;
        }

        .svg {
          width: 2.75rem;
          height: 2.75rem;
        }
      }

      .button {
        width: 100%;
        height: var(--btn-height-large);

        &.buttonLight {
          color: var(--btn-light-color);
          border-top-left-radius: 0;
          border-top-right-radius: 0;
          border-top: 1px solid var(--border-color-main);
          background-color: var(--btn-light-bg);
          text-decoration: none;

          > .svg {
            margin-left: 0.375rem;
            fill: var(--fill-main);
          }

          &:hover {
            color: var(--btn-light-hover-color);
            background-color: var(--btn-light-hover-bg);
          }

          &:active, &:focus {
            color: var(--btn-light-active-color);
            background-color: var(--btn-light-active-bg);
          }
        }
      }

      @media screen and (max-width: 1200px) and (min-width: 981px) {
        &-heading {
          padding-top: 2.5rem;
        }

        &-form {
          .form-item {
            font-size: 0.875rem;

            .button {
              margin-top: 0.5rem;
            }
          }
        }

        &-scl {
          padding-bottom: 2.5rem;

          &-title {
            font-size: 1rem;
          }

          &-item + &-item {
            margin-left: 1.25rem;
          }

          .svg {
            width: 3.375rem;
            height: 3.375rem;
          }
        }

        .button {
          font-size: 1rem;

          &.buttonLight {
            height: 4.375rem;
          }
        }
      }

      @media screen and (max-width: 980px) {
        display: flex;
        flex-direction: column;
        flex-grow: 1;

        &-form {
          .form-item {
            font-size: 0.875rem;

            .button {
              margin-top: 0.5rem;
            }
          }
        }

        &-scl {
          padding-bottom: 2.5rem;

          &-title {
            font-size: 1rem;
          }

          &-item + &-item {
            margin-left: 1.25rem;
          }

          .svg {
            width: 3.375rem;
            height: 3.375rem;
          }
        }

        .button {
          font-size: 1rem;

          &.buttonLight {
            margin-top: auto;
            height: 4.375rem;
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      min-height: 100vh;

      .selectableHeading {
        width: 100%;
        max-width: 25rem;
        &-item {
          font-size: 1.375rem;
        }
      }

      .appModal-header {
        position: static;
        margin-top: auto;
        padding: 0 1.25rem;
      }

      .appModal-body {
        flex-grow: 0;
        height: auto;
        max-height: calc(100vh - 4rem);
        padding-bottom: 4rem;
      }

      .authorization {
        display: flex;
        flex-direction: column;
        justify-content: center;
        padding: 1.25rem;

        .form {
          height: 21rem;
        }

        .button.buttonLight {
          margin-top: auto;
        }
      }
    }
  }
</style>
